<?php

/**
 * investiga_bienes actions.
 *
 * @package    cobro_coactivo
 * @subpackage investiga_bienes
 * @author     ManuelEnriqueParedesLopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class investiga_bienesActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_INVESTIGA_BIENES',
        'CBR_REMISION_TITULO',
        'CBR_REMISION_TIT_AGRUP_V',
        'CBR_ENTIDAD_IB'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_INVESTIGA_BIENES'
        ),
        'CBR_REMISION_TIT_AGRUP_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ENTIDAD_IB' =>
        array(
            'id_entidad_ib' => 'CBR_INVESTIGA_BIENES'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_INVESTIGA_BIENES' =>
        array(
            'id_investiga_bienes' => 'id_investiga_bienes',
            'id_remision_titulo' => 'id_remision_titulo',
            'no_oficio' => 'no_oficio',
            'fecha_envio' => 'fecha_envio',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto',
            'id_entidad_ib' => 'id_entidad_ib',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado'
        ),
        'CBR_REMISION_TIT_AGRUP_V' =>
        array(
            'cod_titulo_det_agrup' => 'cod_titulo_det_agrup',
            'observaciones_det_agrup' => 'observaciones_det_agrup',
            'mineral_det_agrup' => 'mineral_det_agrup'
        ),
        'CBR_ENTIDAD_IB' =>
        array(
            'descripcion' => 'descripcion_entidad'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_INVESTIGA_BIENES' =>
        array(
            'id_investiga_bienes,a' => array('!=' => array(-1)),
            'id_investiga_bienes,b' => array('=' => array('id_investiga_bienes')),
            'id_remision_titulo' => array('=' => array('id_remision_titulo')),
            'id_entidad_ib' => array('=' => array('id_entidad_ib')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_investiga_bienes'; //identificador de la tabla
    protected $id_names = array('id_investiga_bienes'); //llave primaria
    protected $field_names = array('id_remision_titulo', 'id_entidad_ib', 'no_oficio',
        'fecha_envio', 'observaciones', 'adjunto', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_INVESTIGA_BIENES'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_investiga_bienes'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                //Inserta los demas entidades - 20160526
                $entidades = $request['id_entidades'];
                $entidades = explode(',', $entidades);

                $id_remision_titulo = $request['id_remision_titulo'];
                $no_oficio = $request['no_oficio'];
                $fecha_envio = $request['fecha_envio'];
                $observaciones = $request['observaciones'];
                $adjunto = $request['adjunto'];
                $usuario_log = $request['usuario_log'];

                for ($i = 1; $i < count($entidades); $i++) {

                    $id = $entidades[$i];

                    $sql = <<<EOD
INSERT INTO CBR_INVESTIGA_BIENES (id_investiga_bienes, id_remision_titulo, id_entidad_ib, 
    no_oficio, fecha_envio, observaciones, adjunto, usuario_log) 
    VALUES (null, $id_remision_titulo, $id, 
        '$no_oficio', to_date('$fecha_envio', 'YYYY-MM-DD'), '$observaciones', '$adjunto', '$usuario_log') 
EOD;
                    //insertar cada cdp
                    CN_TABLE::executeSQL($sql);
                }

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
                $this->status = 1;
                $this->mensajeError = "[investiga_bienes] Ocurrio un error: " . $e->getMessage();
                $this->list_data = array();
                $this->logMessage("[investiga_bienes] ERROR!");
                $this->logMessage($e->getMessage());
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Campos de log - 20200221
            $request['usuario_log'] = $request['id_username'];

            //Tomo la primera entidad - 20160526
            $request['id_entidad_ib'] = str_replace(".", "", $request['id_entidad_ib']);
            $entidades = $request['id_entidad_ib'];
            $entidades = explode(',', $entidades);

            $id = $entidades[0];
            $request['id_entidades'] = $request['id_entidad_ib'];
            $request['id_entidad_ib'] = $id;
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_remision_titulo = $request['id_remision_titulo'];

        //Tomo la primera entidad - 20160526
        $request['id_entidad_ib'] = str_replace(".", "", $request['id_entidad_ib']);
        $entidades = $request['id_entidad_ib'];
        $entidades = explode(',', $entidades);

        /*
         *  Validar la operación, ya sea por SQL
         */
        for ($i = 0; $i < count($entidades); $i++) {

            $id = $entidades[$i];

            $sql = <<<EOD
SELECT * FROM cbr_investiga_bienes 
where 
id_remision_titulo = $id_remision_titulo 
and id_entidad_ib = $id 
EOD;
            //insertar cada cdp
            $records = CN_TABLE::executeSQL($sql);

            if (count($records) > 0) {
                $errors['mensaje'] = "Ya se ingreso para el titulo una o varias de las mismas entidades de bienes, favor verificar.";
                $errors['servicio'] = "investiga_bienes";
            }
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
